=== src/CMakeLists.txt ===
add_subdirectory(libasr)
add_subdirectory(tests)
add_subdirectory(lfortran)
add_subdirectory(bin)
add_subdirectory(runtime/legacy)
