=== examples/project2/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5 FATAL_ERROR)

project(project2 C Fortran)

add_executable(doconcurrent
    doconcurrent.f90
)
