=== debian/changelog ===
lfortran (0.45.0-1) unstable; urgency=medium

  * New upstream release
  * B-D on re2c for build0.sh script
  * Build-dep on libunwind-dev
  * Call build0.sh before configure
  * Add LSP support
  * Patch for cmake  breaking autopkgtest. Closes: #1094444

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 01 Feb 2025 19:54:57 +0000
