## lfortran 0.48.0

=== src/bin/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,34 @@
-add_executable(lfortran lfortran.cpp)
+set(LFORTRAN_SRC
+    lfortran_command_line_parser.cpp
+    lfortran.cpp
+)
+set(LFORTRAN_LINK_LIBRARIES
+    lfortran_lib
+)
+
+if (WITH_LSP)
+    add_compile_definitions(WITH_LSP)
+    set(LFORTRAN_SRC
+        lfortran_lsp_config.cpp
+        lfortran_lsp_language_server.cpp
+        language_server_interface.cpp
+        ${LFORTRAN_SRC}
+    )
+    set(LFORTRAN_LINK_LIBRARIES
+        ${LFORTRAN_LINK_LIBRARIES}
+        llanguage_server
+    )
+endif()
+
+set(LFORTRAN_SRC
+    lfortran_accessor.cpp
+    lsp_cli.cpp
+    ${LFORTRAN_SRC}
+)
+
+add_executable(lfortran ${LFORTRAN_SRC})
 target_include_directories(lfortran PRIVATE "tpl")
-target_link_libraries(lfortran lfortran_lib)
+target_link_libraries(lfortran ${LFORTRAN_LINK_LIBRARIES})
 if (LFORTRAN_STATIC_BIN)
     if (CMAKE_SYSTEM_NAME STREQUAL "Linux"
         OR CMAKE_SYSTEM_NAME STREQUAL "FreeBSD"
