=== debian/changelog ===
lfortran (0.48.0-1) experimental; urgency=medium

  * New upstream release
  * Standards-Version: 4.7.2
  * Rebase patches
  * No longer use build0.sh script in  d/rules

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 29 May 2025 15:56:43 +0100
