=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: lfortran
 Section: devel
 Priority: optional
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Alastair McKinstry <mckinstry@debian.org>
 Build-Depends:  debhelper-compat (= 13),
